macroScript ChReEn
	category: "Oliver Emley"
	toolTip:"Change Render Engine"
 (	
	try (destroydialog RenderEngineChangeTool) catch()

	CamsFound = #()
	numCamsFound = 0
		
	fn updateCams =(
		for i in cameras do(
			if i.isTarget == false then(
				append CamsFound i.name
				sort CamsFound
			)
			else()
		)
	)
	
	updateCams()
	
	
rollout RenderEngineChangeTool "Render Engine Change" Width: 200
(
	local rc = RendererClass.classes
	
	groupbox GpBxCam "Scene Cameras" width:190 Height:70 pos:[5,0]
		button btnUpdate "Update Camera Drop Down List" width:180 pos:[10,15]
		dropdownlist lb_cams ""  items:CamsFound width:180 pos:[10,40] tooltip:"List of All Cameras in Scene"
		
		on btnUpdate pressed do(
			CamsFound = #()
			updateCams()
			lb_cams.items = CamsFound
		)
		
		on lb_cams selected nameIndex do(
			try(
				lb_cams.selection = nameIndex
				viewport.setCamera (getNodeByName lb_cams.items[nameIndex]) 
			)
			catch(
				temp = lb_cams.items 
				deleteItem temp nameIndex
				lb_cams.items = temp 
			)
		)
		
	groupbox GpBxAsgn "Assign Render Engine" width:190 height:120 pos:[5,75]
	dropdownlist RendDpr items: #(deleteItem rc (findItem rc Missing_Renderer) as string) width:180 pos:[10,130] 
	tooltip: "When in Production Mode Choosing A Renderer From The List Assigns Renderer to Production Mode Slot. When In ActiveShade Mode Choosing A Renderer From The List Assigns Renderer to ActiveShade Mode Slot.   *NOTE ONLY SUPPORTED ACTIVESHADE RENDERERS WILL WORK IN ACTIVESHADE MODE*  "
	
	groupbox GpBxRenD "Render Dialog" width:190 height:66 pos:[5,200]					
	button RSetupOpen "Open" pos:[10,215] tooltip:"Opens Render Setup Dialog"
	button RSetupClose "Close" pos:[60,215] tooltip:"Closes Render Setup Dialog"
	Button RendNow "Render Now" pos:[110,215] tooltip:"Renders Active View"
	checkbox ProdRend "Production Render Mode" pos:[15,90] tooltip: "When checked Production Render Mode is Activated"
	checkbox ActShade "ActiveShade Mode" pos:[15,110]	tooltip: "When Checked ActiveShade Render Mode Is Activated"
	button GLRI "L" pos:[10,240] tooltip:"Get Last Rendered Image"
	checkbox Sng "Single" pos:[40,243] tooltip: "Single Frame Time Output Mode"
	checkbox ActSeg "Active Segment" pos:[95,243] tooltip:"Renders The Active Time Segment"
	
	Groupbox RendOutput "Render Output Size" width:190 height:95 pos:[5,270]
	label Inf_2 "" pos:[90,290] 
		button HI "1920 x 1080" pos:[20,310]
		button Med "1280 x 720" pos:[110,310]
		Button Sm "480 x 270" pos:[26.5,335]
		Button ExSm "320 x 180" pos:[112.5,335]

		-- Credits--
	groupbox GpBxBout  "About" Width:190 Height:100 pos:[5,370]
	label credit1 "Change Render Engines Version 2.1" pos:[15,390]
	label credit2 "Created By Oliver Emley" 
	hyperLink creditLink "www.oliveremley.carbonmade.com" color:[0,0,0] hoverColor:[255,255,255] visitedColor:[0,0,0] address:"http://www.oliveremley.carbonmade.com"
	hyperlink labLink "Email:oliveremley@me.com" align:#center color:(color 0 0 100) hovercolor:(color 0 0 255) visitedcolor:(color 0 0 100) address:"mailto:oliveremley@me.com"
				
	groupbox GpBxCur "Current Renderer" width:170 height: 34 pos:[15,155]
	Label inf "" pos:[100,170]
		
				on RenderEngineChangeTool open do 
									
				(					
					renddpr.items = for r in rc collect (r as string)
					inf.text = (filterString (renderers.current as string) ":")[1]
				
					if renderers.renderDialogMode == #production then
				
					(
					ActShade.checked=False
					ProdRend.checked=True
						renderscenedialog.update()
					)
					else 
					if renderers.renderDialogMode == #ActiveShade then
				
					(
					ActShade.checked=True
					ProdRend.checked=False
						renderscenedialog.update()
					)
					inf_2.text = ("Current Setting =  " + (renderWidth as string) + " x " + (renderHeight as string))
									
				if rendTimeType == 1 do
			(
				Sng.checked=true
				ActSeg.checked=false
			) 
			if rendTimeType == 2 do
			(
				Sng.checked=false
				ActSeg.checked=true
			) 
			if (rendTimeType != 1) and (rendTimeType != 2) do
			(
				Sng.checked=false
				ActSeg.checked=false
			) 
				)	
				
				on rendDpr selected index do 
					(
						renderers.current = rc[index]()
						inf.text = rendDpr.items[index] 
						renderscenedialog.update()
					)
				
	on prodRend changed theState do
	
	(
		if prodRend.checked == true then
		(
			ActShade.checked=False
		renderers.renderDialogMode = #production
			renderscenedialog.update()
		)
		else (false)
		
	)
	
	on ActShade changed theState do
	
	(
		if ActShade.checked == true then
		(
			ProdRend.checked=False
		renderers.renderDialogMode = #ActiveShade
			renderscenedialog.update()
		)
		else (false)
	)	

on Sng changed theStated do
		(
			if Sng.checked == true then
			(
				ActSeg.checked=false
				rendTimeType = 1
				renderSceneDialog.update()
			)
			else (false)
		)
		on ActSeg changed theStated do
		(
			if ActSeg.checked == true then
			(
				Sng.checked=false
				rendTimeType = 2
				renderSceneDialog.update()
			)
			else (false)	
		)

		on HI pressed do 
		(
			renderWidth = 1920
			renderHeight = 1080
			inf_2.text = ("Current Setting =  " + (renderWidth as string) + " x " + (renderHeight as string))
			if renderSceneDialog.isOpen() then renderSceneDialog.update()
		)
on MED pressed do 
		(
			renderWidth = 1280
			renderHeight = 720
			inf_2.text = ("Current Setting =  " + (renderWidth as string) + " x " + (renderHeight as string))
			if renderSceneDialog.isOpen() then renderSceneDialog.update()
		)
		on SM pressed do 
		(
			renderWidth = 480
			renderHeight = 270
			inf_2.text = ("Current Setting =  " + (renderWidth as string) + " x " + (renderHeight as string))
			if renderSceneDialog.isOpen() then renderSceneDialog.update()
		)
		on ExSM pressed do 
		(
			renderWidth = 320
			renderHeight = 180
			inf_2.text = ("Current Setting =  " + (renderWidth as string) + " x " + (renderHeight as string))
			if renderSceneDialog.isOpen() then renderSceneDialog.update()
		)

		on RendNow pressed do
	(
		Max quick render()
		
	)
	
	on RSetupOpen pressed do
	(
		renderSceneDialog.open()  -- Render: Render SetUp open
		)
	
		on RSetupClose pressed do
	(
		renderSceneDialog.Close()  -- Render: Render SetUp close
		)
		

		on GLRI pressed do
		(bm = GetLastRenderedImage copy:false
		display bm
		)
)

CreateDialog  RenderEngineChangeTool -- Create Dialoge
)